<template lang="pug">
form.form( v-if='data' @submit.prevent='submit' )
	b-fields
		b-field( :label='$t("default.client.form.name")' :on-border='true' )
			b-input( v-model='data.name' )
		b-field( label="E-mail" :on-border='true' )
			b-input( v-model='data.email' )
	b-fields
		b-field( :label='$t("default.client.form.phone")' :on-border='true' )
			b-input( v-model='data.phone' )
		b-field( :label='$t("default.client.form.extra_phone")' :on-border='true' )
			b-input( v-model='data.extra_phone' )
	b-fields( v-if='data.messengers' )
		b-field
			.is-flex.is-align-items-center.is-justify-content-flex-start
				b-checkbox( v-model='data.messengers.main.telegram' ) Telegram
				b-checkbox.ml-2( v-model='data.messengers.main.whatsapp' ) Whatsapp
				b-checkbox.ml-2( v-model='data.messengers.main.viber' ) Viber
		b-field
			.is-flex.is-align-items-center.is-justify-content-flex-start
				b-checkbox( v-model='data.messengers.extra.telegram' ) Telegram
				b-checkbox.ml-2( v-model='data.messengers.extra.whatsapp' ) Whatsapp
				b-checkbox.ml-2( v-model='data.messengers.extra.viber' ) Viber
	b-fields
		b-field( :label='$t("default.client.form.birth")' :on-border='true' )
			b-input( v-model='data.birthday' type="birth" )
	b-fields
		b-field( :label='$t("default.client.form.locale")' :on-border='true' )
			b-select( v-model='locale' :data='locales' field="name" )
	b-field
		b-button( node="button" type="primary" :loading='loading' fullwidth ) {{$t("buttons.save")}}
</template>

<script setup>
import BFields from "@/components/form/Fields.vue"
import BField from "@/components/form/Field.vue"
import BInput from "@/components/form/Input.vue"
import BCheckbox from "@/components/form/Checkbox.vue"
import BSelect from "@/components/form/Select.vue"

import { computed, ref, watch } from "vue"

const props = defineProps({
	defaults: {
		type: Object,
		default: () => ({
			name: "",
			email: "",
			birthday: "",
			phone: "",
			extra_phone: "",
			locale: "en",
			messengers: {
				main: {},
				extra: {}
			}
		})
	},
	loading: Boolean
})
const emit = defineEmits([ "submit" ])

const locales = [
	{ name: "Русский", value: "ru" },
	{ name: "English", value: "en" }
]

const data = ref(props.defaults)

const locale = computed({
	get: () => {
		if (data.value.locale == "ru")
			return { name: "Русский", value: "ru" }
		else
			return { name: "English", value: "en" }
	},
	set: ({ value }) => data.value.locale = value
})

watch(() => ({ ...props.defaults }), nv => data.value = nv)

const submit = () => emit("submit", data.value)
</script>